PartModule Class

class NXOpen.Features.PartModule

Bases: NXOpen.Features.Feature

Represents a part module

To create or edit an instance of this class, use NXOpen.Features.PartModuleBuilder

New in version NX8.0.0.

Properties

Property Description
AlgorithmVersion Returns the algorithm version of the feature
AllowDeleteMembers Returns or sets the allow delete members flag.
ContainerFeature Returns the container feature for this feature.
FeatureType Returns the feature type
IsContainedFeature Returns true if the feature is a contained feature.
IsInternal Returns true if the feature is internal.
IsOccurrence Returns whether this object is an occurrence or not.
JournalIdentifier Returns the identifier that would be recorded in a journal for this object.
Location Returns the location of the feature
Name Returns the custom name of the object.
OwningComponent Returns the owning component, if this object is an occurrence.
OwningPart Returns the owning part of this object
Prototype Returns the prototype of this object if it is an occurrence.
Suppressed Returns the suppression status of the feature
Tag Returns the Tag for this object.
Timestamp Returns the timestamp of the feature

Methods

Method Description
Activate Indicates whether the part module is to be activated.
BreakRelationship Breaks part module relationship
BreakWaveLink Break Wave Link Feature
ChangeBooleanType Change Boolean Type
CreateAttributeIterator Create an attribute iterator
CreateLinkedPartModule Creates a linked part module
CreatePartModuleInputBuilder Creates part module input builder
CreatePartModuleOutputBuilder Creates part module output builder
CreatePartModuleOutputBuilder1 Creates new part module output builder
DeleteAllAttributesByType Deletes all attributes of a specific type.
DeleteAttributeByTypeAndTitle Deletes an attribute by type and title.
DeleteClueAlerts Delete all clue alerts from the features
DeleteHintAlerts Delete all clue alerts from the features
DeleteInformationalAlerts Delete all informational alerts from the features
DeleteUserAttribute Deletes the first attribute encountered with the given Type, Title.
DeleteUserAttributes Deletes the attributes on the object, if any, that satisfy the given iterator
DeleteWarningAlerts Delete all warning alerts from the features
DisplayLinkedPart Opens linked part module part
DisplayLinkedPartInNewWindow Opens linked part module part in an additional window if possible, otherwise it will replace active displayed part in existing window.
DisplayMainPart Opens owning part module part
DisplayMainPartInNewWindow Opens owning part module part in an additional window if possible, otherwise it will replace active displayed part in existing window.
FindObject Finds the NXOpen.NXObject with the given identifier as recorded in a journal.
GetAllChildren Returns all immediate child features.
GetAttributeTitlesByType Gets all the attribute titles of a specific type.
GetBooleanUserAttribute Gets a boolean attribute by Title and array Index.
GetChildren Returns the immediate child features.
GetComputationalTimeUserAttribute Gets a time attribute by Title and array Index.
GetEntities Returns the entities created by the feature.
GetExpressions Returns the expressions created by the feature.
GetFeatureClueHintMessages Returns both clue and hint messages of the feature.
GetFeatureClueMessages Returns the feature clue messages.
GetFeatureColor The feature color
GetFeatureErrorMessages Returns the feature error messages.
GetFeatureHintMessages Returns the feature hint messages.
GetFeatureInformationalMessages Returns the feature informational messages.
GetFeatureName Returns the displayed name of the feature.
GetFeatureWarningMessages Returns the feature warning messages.
GetIntegerAttribute Gets an integer attribute by title.
GetIntegerUserAttribute Gets an integer attribute by Title and array Index.
GetNextUserAttribute Gets the next attribute encountered on the object, if any, that satisfies the given iterator.
GetParents Returns the immediate parent features.
GetPdmReferenceAttributeValue Gets the value of PDM Reference attribute for given object.
GetRealAttribute Gets a real attribute by title.
GetRealUserAttribute Gets a real attribute by Title and array Index.
GetReferenceAttribute Gets the reference string (not the calculated value) of a string attribute that uses a reference string.
GetSections Queries a feature for list of its sections.
GetStringAttribute Gets a string attribute value by title.
GetStringUserAttribute Gets a string attribute by Title and array Index.
GetTimeAttribute Gets a time attribute by title.
GetTimeUserAttribute Gets a time attribute by Title and array Index.
GetUserAttribute Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index.
GetUserAttributeAsString Gets the first attribute encountered on the object, if any, with a given title, type and array index.
GetUserAttributeCount Gets the count of set attributes on the object, if any, that satisfy the given iterator.
GetUserAttributeLock Determine the lock of the given attribute.
GetUserAttributeSize Gets the size of the first attribute encountered on the object, if any, with a given Title and Type.
GetUserAttributeSourceObjects Returns an array of objects from which this object presents attributes.
GetUserAttributes Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator.
GetUserAttributesAsStrings Gets all the attributes that have been set on the given object.
HasUserAttribute Determines if an attribute exists on the object, that satisfies the given iterator
HideBody Hide the body created by the feature
HideParents Hide the body created by the parent feature
Highlight Highlight the body created by the feature
LoadInterpartData Loads interpart data for linked part module
LoadPartWithOption Loads own part or inter part of part module based on the input
LogDiagnostic Log a diagnostic alert for this feature
MakeCurrentFeature Make current feature
MakeLinkedWork Opens linked part module part
MakeMainWork Opens owning part module part
MakeSketchExternal Make the parent sketch external for reuse by other features.
MakeSketchInternal Make the parent sketch internal if referenced only by this feature.
Merge Merges part module and its linked part module into a single part module
Print Prints a representation of this object to the system log file.
ProcessDeletePartModule Process the deletion of a Part Module
RemoveForEdit Remove all the feature faces before a NoHistory mode edit.
RemoveParameters Remove Local feature parameters in history free mode.
SetAttribute Creates or modifies an integer attribute.
SetBooleanUserAttribute Creates or modifies a boolean attribute with the option to update or not.
SetGroupActive Set a feature group as active group.
SetName Sets the custom name of the object.
SetPdmReferenceAttribute Sets the value of PDM Reference attribute on the object.
SetReferenceAttribute Creates or modifies a string attribute which uses a reference string.
SetTimeAttribute Creates or modifies a time attribute.
SetTimeUserAttribute Creates or modifies a time attribute with the option to update or not.
SetUserAttribute Creates or modifies an attribute with the option to update or not.
SetUserAttributeLock Lock or unlock the given attribute.
ShowBody Show the body created by the feature.
ShowDimensions Show all feature dimensions of a feature.
ShowOnly Shows all displayable objects of part module and hides all other objects in the part
ShowParents Show the body created by the parent feature.
Suppress Suppress the feature
Unhighlight Unhighlight the body created by the feature
Unsuppress Unsuppress the feature
UpdateInputReferences Updates inputs in the given linked part module
UpdateOutputReferences Updates outputs in the given part module

Enumerations

PartModulePartLoadOption Enumeration Defines part load options

Property Detail

AllowDeleteMembers

PartModule.AllowDeleteMembers

Returns or sets the allow delete members flag.

If true, members of the part module will also be deleted when the part module is deleted. If false, only the part module is deleted

-------------------------------------

Getter Method

Signature AllowDeleteMembers

Returns:the flag specifying whether it is allowed to delete the members of part module when the part module is deleted.
Return type:bool

New in version NX8.0.0.

License requirements: None.

-------------------------------------

Setter Method

Signature AllowDeleteMembers

Parameters:allowDeleteMembers (bool) –

New in version NX8.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

IsOccurrence

PartModule.IsOccurrence

Returns whether this object is an occurrence or not.

-------------------------------------

Getter Method

Signature IsOccurrence

Returns:This object is an occurrence
Return type:bool

New in version NX3.0.0.

License requirements: None.

JournalIdentifier

PartModule.JournalIdentifier

Returns the identifier that would be recorded in a journal for this object.

This may not be the same across different releases of the software.

-------------------------------------

Getter Method

Signature JournalIdentifier

Returns:
Return type:str

New in version NX3.0.0.

License requirements: None.

Name

PartModule.Name

Returns the custom name of the object.

-------------------------------------

Getter Method

Signature Name

Returns:
Return type:str

New in version NX3.0.0.

License requirements: None.

OwningComponent

PartModule.OwningComponent

Returns the owning component, if this object is an occurrence.

-------------------------------------

Getter Method

Signature OwningComponent

Returns:
Return type:NXOpen.Assemblies.Component

New in version NX3.0.0.

License requirements: None.

OwningPart

PartModule.OwningPart

Returns the owning part of this object

-------------------------------------

Getter Method

Signature OwningPart

Returns:The owning part of this object or null if it does not have an owner
Return type:NXOpen.BasePart

New in version NX3.0.0.

License requirements: None.

Prototype

PartModule.Prototype

Returns the prototype of this object if it is an occurrence.

-------------------------------------

Getter Method

Signature Prototype

Returns:The prototype of this object or null if this object is not an occurrence
Return type:NXOpen.INXObject

New in version NX3.0.0.

License requirements: None.

Method Detail

Activate

PartModule.Activate

Indicates whether the part module is to be activated.

If true, the part module will be activated, else, part module will be deactivated

Signature Activate(active)

Parameters:active (bool) –

New in version NX8.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

BreakRelationship

PartModule.BreakRelationship

Breaks part module relationship

Signature BreakRelationship()

New in version NX8.0.0.

License requirements: wave (“WAVE FUNCTIONALITY”)

CreateLinkedPartModule

PartModule.CreateLinkedPartModule

Creates a linked part module

Signature CreateLinkedPartModule(createdPart)

Parameters:createdPart (NXOpen.Part) – part file tag
Returns:the linked part module which is created in given part file
Return type:NXOpen.Features.Feature

New in version NX8.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

CreatePartModuleInputBuilder

PartModule.CreatePartModuleInputBuilder

Creates part module input builder

Signature CreatePartModuleInputBuilder()

Returns:Returns a NXOpen.GeometricUtilities.PartModuleInputBuilder builder
Return type:NXOpen.GeometricUtilities.PartModuleInputBuilder

New in version NX9.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

CreatePartModuleOutputBuilder

PartModule.CreatePartModuleOutputBuilder

Creates part module output builder

This API is now deprecated. Please use NXOpen.Features.PartModule.CreatePartModuleOutputBuilder1() instead.

Signature CreatePartModuleOutputBuilder()

Returns:Returns a NXOpen.GeometricUtilities.PartModuleOutputBuilder builder
Return type:NXOpen.GeometricUtilities.PartModuleOutputBuilder

New in version NX8.0.0.

Deprecated since version NX9.0.0: Please use NXOpen.Features.PartModule.CreatePartModuleOutputBuilder1() instead.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

CreatePartModuleOutputBuilder1

PartModule.CreatePartModuleOutputBuilder1

Creates new part module output builder

Signature CreatePartModuleOutputBuilder1()

Returns:Returns a NXOpen.GeometricUtilities.PartModuleOutputBuilder1 builder
Return type:NXOpen.GeometricUtilities.PartModuleOutputBuilder1

New in version NX9.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

DisplayLinkedPart

PartModule.DisplayLinkedPart

Opens linked part module part

Signature DisplayLinkedPart()

New in version NX10.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

DisplayLinkedPartInNewWindow

PartModule.DisplayLinkedPartInNewWindow

Opens linked part module part in an additional window if possible, otherwise it will replace active displayed part in existing window.

Signature DisplayLinkedPartInNewWindow()

New in version NX12.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

DisplayMainPart

PartModule.DisplayMainPart

Opens owning part module part

Signature DisplayMainPart()

New in version NX10.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

DisplayMainPartInNewWindow

PartModule.DisplayMainPartInNewWindow

Opens owning part module part in an additional window if possible, otherwise it will replace active displayed part in existing window.

Signature DisplayMainPartInNewWindow()

New in version NX12.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

FindObject

PartModule.FindObject

Finds the NXOpen.NXObject with the given identifier as recorded in a journal.

An object may not return the same value as its JournalIdentifier in different versions of the software. However newer versions of the software should find the same object when FindObject is passed older versions of its journal identifier. In general, this method should not be used in handwritten code and exists to support record and playback of journals.

An exception will be thrown if no object can be found with the given journal identifier.

Signature FindObject(journalIdentifier)

Parameters:journalIdentifier (str) – Journal identifier of the object
Returns:
Return type:NXOpen.INXObject

New in version NX3.0.0.

License requirements: None.

LoadInterpartData

PartModule.LoadInterpartData

Loads interpart data for linked part module

Signature LoadInterpartData()

New in version NX8.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

LoadPartWithOption

PartModule.LoadPartWithOption

Loads own part or inter part of part module based on the input

Signature LoadPartWithOption(partLoadOption)

Parameters:partLoadOption (int) – the part load options defined in NXOpen.Features.PartModulePartLoadOption. This argument will accept combination of load options
Returns:
Return type:NXOpen.Part

New in version NX10.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

MakeLinkedWork

PartModule.MakeLinkedWork

Opens linked part module part

Signature MakeLinkedWork()

New in version NX8.0.0.

Deprecated since version NX10.0.0: Please use NXOpen.Features.PartModule.DisplayLinkedPart() instead.

License requirements: solid_modeling (“SOLIDS MODELING”)

MakeMainWork

PartModule.MakeMainWork

Opens owning part module part

Signature MakeMainWork()

New in version NX8.0.0.

Deprecated since version NX10.0.0: Please use NXOpen.Features.PartModule.DisplayMainPart() instead.

License requirements: solid_modeling (“SOLIDS MODELING”)

Merge

PartModule.Merge

Merges part module and its linked part module into a single part module

Signature Merge()

New in version NX8.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

Print

PartModule.Print

Prints a representation of this object to the system log file.

Signature Print()

New in version NX3.0.0.

License requirements: None.

ProcessDeletePartModule

PartModule.ProcessDeletePartModule

Process the deletion of a Part Module

Signature ProcessDeletePartModule()

New in version NX9.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

SetName

PartModule.SetName

Sets the custom name of the object.

NOTE: This method should not be used to edit a read-only object such as a Mirrored PMI object. If it is, the changes will be overridden when the part is updated.

Signature SetName(name)

Parameters:name (str) –

New in version NX3.0.0.

License requirements: None.

ShowOnly

PartModule.ShowOnly

Shows all displayable objects of part module and hides all other objects in the part

Signature ShowOnly()

New in version NX8.0.0.

License requirements: solid_modeling (“SOLIDS MODELING”)

UpdateInputReferences

PartModule.UpdateInputReferences

Updates inputs in the given linked part module

Signature UpdateInputReferences()

New in version NX8.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)

UpdateOutputReferences

PartModule.UpdateOutputReferences

Updates outputs in the given part module

Signature UpdateOutputReferences()

New in version NX8.0.0.

License requirements: usr_defined_features (“USER DEFINED FEATURES”)